local b1 = CreateFrame("Button","TargetMob",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b2 = CreateFrame("Button","TargetPlayer",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")

local f1 = CreateFrame("Frame","PlayerStats",UIParent,"TooltipBorderedFrameTemplate")
local f2 = CreateFrame("Frame","CombatStats",UIParent,"TooltipBorderedFrameTemplate")
local f3 = CreateFrame("Frame","QuestStats",UIParent,"TooltipBorderedFrameTemplate")

local t1 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t2 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t3 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t5 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t8 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t9 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")

local t6 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t16 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t17 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t10 = b1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t11 = b1:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local t12 = b2:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t13 = b2:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local pMissCount = 0
local pSwingAmount, pSwingCount = 0, 0
local pRangeAmount, pRangeCount = 0, 0
local pSpellAmount, pSpellCount = 0, 0
local pDamageAmount, pDamageCount = 0,0

local pHealAmount, pHealCount = 0, 0
local tHealAmount, tHealCount = 0, 0
local sHealAmount, sHealCount = 0, 0

local pGearAmount, pGearCount = 0, 0
local pGearArea, pStatArea = "Gear", "Stats"
local qText, xText, eText = " ", " ", " "

b1:EnableMouse(true)
b1:SetMovable(true)
b1:SetClampedToScreen(true)
b1:RegisterForDrag("RightButton")
b1:SetScript("OnDragStart", b1.StartMoving)
b1:SetScript("OnDragStop", b1.StopMovingOrSizing)
b1:RegisterForClicks("AnyUp")
b1:SetAttribute("type", "macro")
b1:SetAttribute("macrotext", "/target player")
b1:SetPoint("CENTER")
b1:SetSize(320, 80)

t10:SetPoint("TOPLEFT",6, -6)
t10:SetWidth(300)
t10:SetHeight(66)
t10:SetJustifyH("LEFT")
t10:SetTextColor(1,0,0,1)

t11:SetPoint("TOPLEFT",6, -6)
t11:SetWidth(300)
t11:SetHeight(66)
t11:SetJustifyH("RIGHT")
t11:SetTextColor(1,0.5,0.5,1)

b2:EnableMouse(true)
b2:SetMovable(true)
b2:SetClampedToScreen(true)
b2:RegisterForDrag("RightButton")
b2:SetScript("OnDragStart", b2.StartMoving)
b2:SetScript("OnDragStop", b2.StopMovingOrSizing)
b2:RegisterForClicks("AnyUp")
b2:SetAttribute("type", "macro")
b2:SetAttribute("macrotext", "/cleartarget\n/stopcasting\n/stopattack\n/targetenemy [noexists][dead]\n/startattack")
b2:SetPoint("CENTER")
b2:SetSize(320, 80)

t12:SetPoint("TOPLEFT",6, -6)
t12:SetWidth(300)
t12:SetHeight(66)
t12:SetJustifyH("LEFT")
t12:SetTextColor(1,0,0,1)

t13:SetPoint("TOPLEFT",6, -6)
t13:SetWidth(300)
t13:SetHeight(66)
t13:SetJustifyH("RIGHT")
t13:SetTextColor(1,0.5,0.5,1)

f1:SetWidth(288)
f1:SetHeight(390)
f1:SetAlpha(.90)
f1:SetPoint("CENTER",-200,220)
f1:SetMovable(true)
f1:EnableMouse(true)
f1:SetClampedToScreen(true)
f1:RegisterForDrag("RightButton")
f1:RegisterEvent("UNIT_HEALTH_FREQUENT")
f1:RegisterEvent("UNIT_POWER_FREQUENT")
f1:RegisterEvent("UNIT_TARGET")
f1:RegisterEvent("UNIT_COMBAT")
f1:RegisterEvent("QUEST_DETAIL")
f1:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f1:SetScript("OnDragStart", f1.StartMoving)
f1:SetScript("OnDragStop", f1.StopMovingOrSizing)
f1:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then f1:Hide() end 
end)
f1:SetScript("OnEvent", function(self, event, ...)
	if(event == "UNIT_HEALTH_FREQUENT") then ShowStats() end
	if(event == "UNIT_POWER_FREQUENT") then ShowStats() end
	if(event == "UNIT_TARGET") then UpdateCombat() ; ShowStats() end
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then SendStatus(self, CombatLogGetCurrentEventInfo()) ; ShowStats() end
	if(event == "QUEST_DETAIL") then AcceptQuest() end
end)

t1:SetPoint("TOPLEFT", 20, -12)
t1:SetWidth(234)
t1:SetHeight(364)
t1:SetJustifyH("LEFT")

t2:SetPoint("TOPLEFT", 20, -12)
t2:SetWidth(234)
t2:SetHeight(364)
t2:SetJustifyH("RIGHT")

f2:SetWidth(306)
f2:SetHeight(240)
f2:SetAlpha(.90)
f2:SetPoint("CENTER",0,0)
f2:SetMovable(true)
f2:EnableMouse(true)
f2:SetClampedToScreen(true)
f2:RegisterForDrag("RightButton")
f2:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then ResetAllAreas() end
end)
f2:SetScript("OnDragStart", f2.StartMoving)
f2:SetScript("OnDragStop", f2.StopMovingOrSizing)

t3:SetPoint("TOPLEFT",8, -8)
t3:SetWidth(290)
t3:SetHeight(220)
t3:SetJustifyH("LEFT")

t5:SetPoint("TOPLEFT", 74, -8)
t5:SetWidth(80)
t5:SetHeight(220)
t5:SetJustifyH("RIGHT")

t8:SetPoint("TOPLEFT", 144, -8)
t8:SetWidth(80)
t8:SetHeight(220)
t8:SetJustifyH("RIGHT")

t9:SetPoint("TOPLEFT", 214, -8)
t9:SetWidth(80)
t9:SetHeight(220)
t9:SetJustifyH("RIGHT")

f3:SetWidth(360)
f3:SetHeight(420)
f3:SetAlpha(.90)
f3:SetPoint("CENTER",0,200)
f3:SetMovable(true)
f3:EnableMouse(true)
f3:SetClampedToScreen(true)
f3:RegisterForDrag("RightButton")
f3:SetScript("OnDragStart", f2.StartMoving)
f3:SetScript("OnDragStop", f2.StopMovingOrSizing)
f3:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then f3:Hide() end
end)

t6:SetPoint("TOPLEFT", 6, -8)
t6:SetWidth(200)
t6:SetHeight(384)
t6:SetJustifyH("LEFT")

t16:SetPoint("TOPLEFT", 206, -8)
t16:SetWidth(70)
t16:SetHeight(384)
t16:SetJustifyH("RIGHT")

t17:SetPoint("TOPLEFT", 276, -8)
t17:SetWidth(80)
t17:SetHeight(384)
t17:SetJustifyH("RIGHT")

f1:Show() ; f2:Show() ; f3:Show() ; b1:Show() ; b2:Show()

function ResetAllAreas()
	pMissCount = 0
	pSwingAmount, pSwingCount = 0, 0
	pRangeAmount, pRangeCount = 0, 0
	pSpellAmount, pSpellCount = 0, 0
	pDamageAmount, pDamageCount = 0,0

	pHealAmount, pHealCount = 0, 0
	tHealAmount, tHealCount = 0, 0
	sHealAmount, sHealCount = 0, 0

	pGearAmount, pGearCount = 0, 0
	pGearArea, pStatArea = "Gear", "Stats"

	f1:Show() ; f3:Show()
end

function SendStatus(self, ...)
	local playerUsed = UnitGUID("player")
	local targetUsed = UnitGUID("target")
	local _, eventtype, _, sourceGUID, _, _, _, destGUID, _, _, _ = ...
	if(sourceGUID == playerUsed) then
		if(eventtype == "SWING_DAMAGE") then
			local amount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSwingCount = pSwingCount + 1 ; pSwingAmount = pSwingAmount + amount
		end
		if(eventtype == "SPELL_DAMAGE") then
			local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + spellamount
		end
		if(eventtype == "SPELL_PERIODIC_DAMAGE") then
			local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + spellamount
		end
		if(eventtype == "RANGE_DAMAGE") then
			local _, _, _, rangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pRangeCount = pRangeCount + 1 ; pRangeAmount = pRangeAmount + rangeamount
		end

		if(eventtype == "SWING_MISSED") then pMissCount = pMissCount + 1 end
		if(eventtype == "SPELL_MISSED") then pMissCount = pMissCount + 1 end
		if(eventtype == "RANGE_MISSED") then pMissCount = pMissCount + 1 end

		if(destGUID == playerUsed) then
			if(eventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + spellamount
			end
		end
		if(destGUID ~= playerUsed) then
			if(eventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + spellamount
			end
		end
	end
	if(sourceGUID ~= playerUsed) then
		if(destGUID == playerUsed) then
			if(eventtype == "SWING_DAMAGE") then
				local amount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + amount
			end
			if(eventtype == "SPELL_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(eventtype == "RANGE_DAMAGE") then
				local _, _, _, rangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + rangeamount
			end

			if(eventtype == "SWING_MISSED") then pDamageCount = pDamageCount + 1 end
			if(eventtype == "SPELL_MISSED") then pDamageCount = pDamageCount + 1 end
			if(eventtype == "RANGE_MISSED") then pDamageCount = pDamageCount + 1 end

			if(eventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
		end
	end
end

function UpdateGearView(self, gearName, gearLevel)
	local gearStat = 0
	if(gearLevel == nil) then gearStat = 0 end
	if(gearLevel ~= nil) then gearStat = gearLevel end
	pGearArea = pGearArea .. "\n" .. gearName
	pStatArea = pStatArea .. "\n" .. gearStat
	pGearCount = pGearCount + 1
	pGearAmount = pGearAmount + gearStat
end

function UpdateMainHand()
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("MainHandSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Main Hand", wLvl) end
end

function UpdateSecondary() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("SecondaryHandSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Off Hand", wLvl) end
end

function UpdateHead() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("HeadSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Head", wLvl) end
end

function UpdateNeck() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("NeckSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Neck", wLvl) end
end

function UpdateShoulder() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("ShoulderSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Shoulder", wLvl) end
end

function UpdateBack() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("BackSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Back", wLvl) end
end

function UpdateChest() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("ChestSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Chest", wLvl) end
end

function UpdateWrist() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("WristSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Wrist", wLvl) end
end

function UpdateHands() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("HandsSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Hands", wLvl) end
end

function UpdateWaist() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("WaistSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Waist", wLvl) end
end

function UpdateLegs() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("LegsSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Legs", wLvl) end
end

function UpdateFeet() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("FeetSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Feet", wLvl) end
end

function UpdateFingerOne() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Finger0Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Finger", wLvl) end
end

function UpdateFingerTwo() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Finger1Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Finger", wLvl) end
end

function UpdateTrinketOne() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Trinket0Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Trinket", wLvl) end
end

function UpdateTrinketTwo() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Trinket1Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Trinket", wLvl) end
end

function UpdateGear()
	pGearCount, pGearAmount = 0, 0
	pGearArea, pStatArea = " ", " "
	UpdateMainHand() ; UpdateSecondary() ; UpdateHead() ; UpdateNeck()
	UpdateBack() ; UpdateShoulder(); UpdateChest() ; UpdateWrist()
	UpdateHands() ;  UpdateWaist() ; UpdateLegs() ; UpdateFeet()
	UpdateFingerOne() ; UpdateFingerTwo() ; UpdateTrinketOne() ; UpdateTrinketTwo()
	pGearArea = pGearArea .. "\n" .. "Equipped"
	if(pGearCount > 0) then pStatArea = pStatArea .. "\n" .. format("%.0f", (pGearAmount / pGearCount)) end
end

function UpdateStats()
	local pCrit = format("%.2f%%", GetCritChance())
	local sCrit = format("%.2f%%", GetSpellCritChance())
	local rCrit = format("%.2f%%", GetRangedCritChance())
	local pHit, base = GetManaRegen()
	local cSpeed, rSpeed, fSpeed, sSpeed = GetUnitSpeed("player")
	local bPwr, pPwr, nPwr = UnitAttackPower("player")
	local rbPwr, rpPwr, rnPwr = UnitRangedAttackPower("player")
	local ePwr = bPwr + pPwr + nPwr
	local rePwr = rbPwr + rpPwr + rnPwr
	local saText = "Attack\nRanged\n\nMelee Crit\nSpell Crit\nRanged Crit\n\nMana Regen\nCombat Regen\nMove Speed\n" .. pGearArea
	local sbText = ePwr .. "\n" .. rePwr .. "\n\n" .. pCrit .. "\n" .. sCrit .. "\n" .. rCrit .. "\n\n" .. format("%.2f", (base * 2)) .. "\n" .. format("%.2f", (pHit * 2)) .. "\n" .. format("%.0f", cSpeed) .. "\n" .. pStatArea
	t1:SetText(saText) ; t2:SetText(sbText)
end

function UpdatePlayer()
	local pName = UnitName("player")
	if(pName ~= nil) then
		local pHealth = UnitHealth("player")
		local pMana = UnitPower("player")
		local pText = pName .. "\n\n" .. "Power"
		local pvText = pHealth .. "\n" .. pMana
		t10:SetText(pText)
		t11:SetText(pvText)
	end
end

function UpdateTarget()
	local mName = UnitName("target")
	if(mName ~= nil) then
		local mHealth = UnitHealth("target")
		local mMana = UnitPower("target")
		local tText = mName .. "\n\n" .. "Power"
		local tvText = mHealth .. "\n" .. mMana
		t12:SetText(tText)
		t13:SetText(tvText)
	end
end

function UpdateCombat()	
	local pTotalAvg, pSwingAvg, pRangeAvg, pSpellAvg = 0, 0, 0, 0
	local pDamageAvg, pHealAvg, tHealAvg, sHealAvg, pHealTotalAvg = 0, 0, 0, 0, 0

	local pTotalAmount = pSpellAmount + pSwingAmount + pRangeAmount
	local pTotalCount = pSpellCount + pSwingCount + pRangeCount + pMissCount

	local pHealTotalAmount = pHealAmount + tHealAmount + sHealAmount
	local pHealTotalCount = pHealCount + tHealCount + sHealCount

	local vText = " \nMissed\nSwing\nSpell\nRange\nAttacks\n\nHealed\nHealing\nHealers\nHeals\n\nDamage"
	local lText = format("%8s", "Hits")
	local kText = format("%8s", "Avg")
	local gText = format("%8s", "Total")
	
	if(pSwingCount > 0) then pSwingAvg = (pSwingAmount / pSwingCount); end
	if(pRangeCount > 0) then pRangeAvg = (pRangeAmount / pRangeCount); end
	if(pSpellCount > 0) then pSpellAvg = (pSpellAmount / pSpellCount); end
	if(pTotalCount > 0) then pTotalAvg = (pTotalAmount / pTotalCount); end

	if(pHealCount > 0) then pHealAvg = (pHealAmount / pHealCount); end
	if(tHealCount > 0) then tHealAvg = (tHealAmount / tHealCount); end
	if(sHealCount > 0) then sHealAvg = (sHealAmount / sHealCount); end
	if(pHealTotalCount > 0) then pHealTotalAvg = (pHealTotalAmount / pHealTotalCount); end

	if(pDamageCount > 0) then pDamageAvg = pDamageAmount / pDamageCount end

	lText = lText .. "\n" .. format("%8d", pMissCount)
	lText = lText .. "\n" .. format("%8d", pSwingCount)
	lText = lText .. "\n" .. format("%8d", pSpellCount)
	lText = lText .. "\n" .. format("%8d", pRangeCount)
	lText = lText .. "\n" .. format("%8d", pTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pHealCount)
	lText = lText .. "\n" .. format("%8d", tHealCount)
	lText = lText .. "\n" .. format("%8d", sHealCount)
	lText = lText .. "\n" .. format("%8d", pHealTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pDamageCount)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pSwingAvg)
	kText = kText .. "\n" .. format("%8d", pSpellAvg)
	kText = kText .. "\n" .. format("%8d", pRangeAvg)
	kText = kText .. "\n" .. format("%8d", pTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pHealAvg)
	kText = kText .. "\n" .. format("%8d", tHealAvg)
	kText = kText .. "\n" .. format("%8d", sHealAvg)
	kText = kText .. "\n" .. format("%8d", pHealTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pDamageAvg)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%8d", pSwingAmount)
	gText = gText .. "\n" .. format("%8d", pSpellAmount)
	gText = gText .. "\n" .. format("%8d", pRangeAmount)
	gText = gText .. "\n" .. format("%8d", pTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%8d", pHealAmount)
	gText = gText .. "\n" .. format("%8d", tHealAmount)
	gText = gText .. "\n" .. format("%8d", sHealAmount)
	gText = gText .. "\n" .. format("%8d", pHealTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%8d", pDamageAmount)

	t3:SetText(vText)
	t5:SetText(lText)
	t8:SetText(kText)
	t9:SetText(gText)
end

function UpdateExperience()
	local pLvl = UnitLevel("player")
	local pExp = UnitXP("player")
	local pExpMax = UnitXPMax("player")
	local tExp = pExpMax - pExp
	local pXPLvl = ((pLvl * 5) + 45)
	local tExpCount = tExp / pXPLvl
	local pPosY, pPosX, pPosZ, pInstance = UnitPosition("player")

	qText ="Location:\n" .. "NPC Level " .. pLvl .. " (" .. pXPLvl .. " xp)\nExperience\n"
	xText = format("%0d", (pPosY / 100)) .. "\n\n\n"
	eText = format("%0d", (pPosX / 100)) .. "\n".. format("%.0f", tExpCount) .. "\n" .. tExp .. "\n"
end

function UpdateZone()
	local pLvl = UnitLevel("player")

	qText = qText .. "\n" .. "Zone\n"
	xText = xText .. "\n" .. "Lvl\n"
	eText = eText .. "\n" .. "Max\n"

	if(pLvl < 10) then 
		qText = qText .. "\n" .. "Dun Morogh\nDurotar\nElwynn Forest\nMulgore\nTeldrassil\nTirisfal Glades"
		xText = xText .. "\n" .. "1\n1\n1\n1\n1\n1"
		eText = eText .. "\n" .. "10\n10\n10\n10\n10\n10"
	end
	if(pLvl > 9) then
		if(pLvl < 19) then 
			qText = qText .. "\n" .. "Darkshore\nLock Modan\nSilverpine Forest\nWestfall"
			xText = xText .. "\n" .. "10\n10\n10\n10"
			eText = eText .. "\n" .. "20\n20\n20\n20"
		end
		if(pLvl > 14) then
			if(pLvl < 26) then 
				qText = qText .. "\n" .. "Redridge Mountains"
				xText = xText .. "\n" .. "15"
				eText = eText .. "\n" .. "25"
			end
			if(pLvl < 28) then 
				qText = qText .. "\n" .. "Stonetalon Mountains"
				xText = xText .. "\n" .. "15"
				eText = eText .. "\n" .. "27"
			end
		end
		if(pLvl > 17) then
			if(pLvl < 31) then 
				qText = qText .. "\n" .. "Ashenvale"
				xText = xText .. "\n" .. "18"
				eText = eText .. "\n" .. "30"
				qText = qText .. "\n" .. "Duskwood"
				xText = xText .. "\n" .. "18"
				eText = eText .. "\n" .. "30"
			end
		end
		if(pLvl > 19) then
			if(pLvl < 31) then 
				qText = qText .. "\n" .. "Hillsbrad Foothills"
				xText = xText .. "\n" .. "20"
				eText = eText .. "\n" .. "30"
				qText = qText .. "\n" .. "Wetlands"
				xText = xText .. "\n" .. "20"
				eText = eText .. "\n" .. "30"
			end
		end
	end
	if(pLvl > 24) then
		if(pLvl < 36) then
			qText = qText .. "\n" .. "Thousand Needles"
			xText = xText .. "\n" .. "25"
			eText = eText .. "\n" .. "35"
		end
		if(pLvl < 31) then 
			qText = qText .. "\n" .. "Hillsbrad Foothills"
			xText = xText .. "\n" .. "20"
			eText = eText .. "\n" .. "30"
			qText = qText .. "\n" .. "Wetlands"
			xText = xText .. "\n" .. "20"
			eText = eText .. "\n" .. "30"
			qText = qText .. "\n" .. "Ashenvale"
			xText = xText .. "\n" .. "18"
			eText = eText .. "\n" .. "30"
			qText = qText .. "\n" .. "Duskwood"
			xText = xText .. "\n" .. "18"
			eText = eText .. "\n" .. "30"
		end
		if(pLvl < 28) then
			qText = qText .. "\n" .. "Stonetalon Mountains"
			xText = xText .. "\n" .. "15"
			eText = eText .. "\n" .. "27"
		end
		if(pLvl < 26) then
			qText = qText .. "\n" .. "Redridge Mountains"
			xText = xText .. "\n" .. "15"
			eText = eText .. "\n" .. "25"
		end
	end
	if(pLvl > 30) then
		if(pLvl < 46) then
			qText = qText .. "\n" .. "Stranglethorn Vale"
			xText = xText .. "\n" .. "30"
			eText = eText .. "\n" .. "45"
			if(pLvl > 34) then 
				qText = qText .. "\n" .. "Duskwallow Marsh"
				xText = xText .. "\n" .. "35"
				eText = eText .. "\n" .. "45"
				qText = qText .. "\n" .. "Badlands"
				xText = xText .. "\n" .. "35"
				eText = eText .. "\n" .. "45"
				qText = qText .. "\n" .. "Swamp of Sorrows"
				xText = xText .. "\n" .. "35"
				eText = eText .. "\n" .. "45"
			end
		end
		if(pLvl < 41) then 
			qText = qText .. "\n" .. "Alterac Mountains"
			xText = xText .. "\n" .. "30"
			eText = eText .. "\n" .. "40"
			qText = qText .. "\n" .. "Arathi Highlands"
			xText = xText .. "\n" .. "30"
			eText = eText .. "\n" .. "40"
			qText = qText .. "\n" .. "Desolace"
			xText = xText .. "\n" .. "30"
			eText = eText .. "\n" .. "40"
		end
	end
	if(pLvl > 39) then
		if(pLvl < 51) then 
			qText = qText .. "\n" .. "Feralas"
			xText = xText .. "\n" .. "40"
			eText = eText .. "\n" .. "50"
			qText = qText .. "\n" .. "Hinterlands"
			xText = xText .. "\n" .. "40"
			eText = eText .. "\n" .. "50"
			qText = qText .. "\n" .. "Tanaris"
			xText = xText .. "\n" .. "40"
			eText = eText .. "\n" .. "50"
		end
		if(pLvl > 44) then 
			qText = qText .. "\n" .. "Searing Gorge"
			xText = xText .. "\n" .. "45"
			eText = eText .. "\n" .. "50"
		end
	end
	if(pLvl > 45) then
		if(pLvl < 59) then 
			qText = qText .. "\n" .. "Azshara"
			xText = xText .. "\n" .. "45"
			eText = eText .. "\n" .. "55"
			qText = qText .. "\n" .. "Blasted Lands"
			xText = xText .. "\n" .. "45"
			eText = eText .. "\n" .. "55"
			qText = qText .. "\n" .. "Un'goro Crater"
			xText = xText .. "\n" .. "48"
			eText = eText .. "\n" .. "55"
			qText = qText .. "\n" .. "Felwood"
			xText = xText .. "\n" .. "48"
			eText = eText .. "\n" .. "55"
			qText = qText .. "\n" .. "Burning Steppes"
			xText = xText .. "\n" .. "50"
			eText = eText .. "\n" .. "58"
			qText = qText .. "\n" .. "Western Plaguelands"
			xText = xText .. "\n" .. "51"
			eText = eText .. "\n" .. "58"
		end
		if(pLvl < 51) then 
			qText = qText .. "\n" .. "Searing Gorge"
			xText = xText .. "\n" .. "45"
			eText = eText .. "\n" .. "50"
		end	
	end
	if(pLvl > 52) then
		qText = qText .. "\n" .. "Eastern Plaguelands"
		xText = xText .. "\n" .. "53"
		eText = eText .. "\n" .. "60"
		qText = qText .. "\n" .. "Winterspring"
		xText = xText .. "\n" .. "53"
		eText = eText .. "\n" .. "60"
		qText = qText .. "\n" .. "Deadwing Pass"
		xText = xText .. "\n" .. "59"
		eText = eText .. "\n" .. "60"
		qText = qText .. "\n" .. "Moonglade"
		xText = xText .. "\n" .. "59"
		eText = eText .. "\n" .. "60"
		qText = qText .. "\n" .. "Silithus"
		xText = xText .. "\n" .. "59"
		eText = eText .. "\n" .. "60"
		if(pLvl < 59) then 
			qText = qText .. "\n" .. "Burning Steppes"
			xText = xText .. "\n" .. "50"
			eText = eText .. "\n" .. "58"
			qText = qText .. "\n" .. "Western Plaguelands"
			xText = xText .. "\n" .. "51"
			eText = eText .. "\n" .. "58"
		end	
	end
end

function UpdateDungeon()
	local dLvl = UnitLevel("player")

	qText = qText .. "\n\n" .. "Dungeon\n"
	xText = xText .. "\n\n" .. "Lvl\n"
	eText = eText .. "\n\n" .. "Max\n"

	if(dLvl > 12) then
		if(dLvl < 19) then 
			qText = qText .. "\n" .. "Ragefire Chasm (RFC)"
			xText = xText .. "\n" .. "13"
			eText = eText .. "\n" .. "18"
		end
	end
	if(dLvl > 16) then
		if(dLvl < 25) then 
			qText = qText .. "\n" .. "Wailing Caverns (WC)"
			xText = xText .. "\n" .. "18"
			eText = eText .. "\n" .. "25"
		end
		if(dLvl < 27) then 
			qText = qText .. "\n" .. "The Deadmines (VC)"
			xText = xText .. "\n" .. "18"
			eText = eText .. "\n" .. "25"
		end
	end
	if(dLvl > 21) then
		if(dLvl < 30) then 
			qText = qText .. "\n" .. "Shadowfang Keep (SFK)"
			xText = xText .. "\n" .. "18"
			eText = eText .. "\n" .. "25"
		end
	end
	if(dLvl > 24) then
		if(dLvl < 32) then 
			qText = qText .. "\n" .. "Blackfathom Deeps (BFD)"
			xText = xText .. "\n" .. "24"
			eText = eText .. "\n" .. "32"
			qText = qText .. "\n" .. "The Stockade (Stocks)"
			xText = xText .. "\n" .. "23"
			eText = eText .. "\n" .. "50"
		end
	end
	if(dLvl > 28) then
		if(dLvl < 33) then
			qText = qText .. "\n" .. "Gnomeregan (Gnomer)"
			xText = xText .. "\n" .. "23"
			eText = eText .. "\n" .. "38"
			qText = qText .. "\n" .. "Razorfen Kraul"
			xText = xText .. "\n" .. "29"
 			eText = eText .. "\n" .. "38"
		end
	end
	if(dLvl > 33) then
		if(dLvl < 39) then
			qText = qText .. "\n" .. "Gnomeregan (Gnomer)"
			xText = xText .. "\n" .. "23"
			eText = eText .. "\n" .. "38"
			qText = qText .. "\n" .. "Razorfen Kraul"
			xText = xText .. "\n" .. "29"
 			eText = eText .. "\n" .. "38"
		end	
		if(dLvl < 45) then 
			qText = qText .. "\n" .. "The Scarlet Monastery (SM)"
			xText = xText .. "\n" .. "30"
			eText = eText .. "\n" .. "44"
		end
	end
	if(dLvl > 36) then
		if(dLvl < 47) then 
			qText = qText .. "\n" .. "Razorfen Downs (RFD)"
			xText = xText .. "\n" .. "37"
			eText = eText .. "\n" .. "46"
		end
	end
	if(dLvl > 40) then
		if(dLvl < 52) then 
			qText = qText .. "\n" .. "Uldaman (ULDA)"
			xText = xText .. "\n" .. "41"
			eText = eText .. "\n" .. "51"
		end
	end
	if(dLvl > 43) then
		if(dLvl < 50) then 
			qText = qText .. "\n" .. "Zul'Farrak (ZF)"
			xText = xText .. "\n" .. "44"
			eText = eText .. "\n" .. "49"
		end
	end
	if(dLvl > 45) then
		if(dLvl < 56) then 
			qText = qText .. "\n" .. "Maraudon (MARA)"
			xText = xText .. "\n" .. "46"
			eText = eText .. "\n" .. "56"
		end
	end
	if(dLvl > 49) then
		if(dLvl < 57) then 
			qText = qText .. "\n" .. "Temple of Atal'Hakkar (ST)"
			xText = xText .. "\n" .. "50"
			eText = eText .. "\n" .. "56"
		end
	end
	if(dLvl > 51) then
		if(dLvl < 61) then
			qText = qText .. "\n" .. "Blackrock Depths (BRD)"
			xText = xText .. "\n" .. "49"
			eText = eText .. "\n" .. "56"
		end
	end
	if(dLvl > 54) then 
		if(dLvl < 61) then
			qText = qText .. "\n" .. "Lower Blackrock Spire (LBRS)"
			xText = xText .. "\n" .. "56"
			eText = eText .. "\n" .. "60"
			qText = qText .. "\n" .. "Diremaul (DM)"
			xText = xText .. "\n" .. "55"
			eText = eText .. "\n" .. "60"
			qText = qText .. "\n" .. "Upper Blackrock Spire (UBRS) (Raid 10)"
			xText = xText .. "\n" .. "55"
			eText = eText .. "\n" .. "60"
			if(dLvl > 58) then
				qText = qText .. "\n" .. "Stratholme (STRAT)"
				xText = xText .. "\n" .. "58"
				eText = eText .. "\n" .. "60"
				qText = qText .. "\n" .. "Scholomance (SCHOLO)"
				xText = xText .. "\n" .. "58"
				eText = eText .. "\n" .. "60"
			end
		end
	end
end

function ShowStats()
	UpdateExperience()
	UpdateGear()
	UpdateStats()
	UpdatePlayer()
	UpdateTarget()
	UpdateCombat()
	UpdateZone()
	UpdateDungeon()
	t6:SetText(qText)
	t16:SetText(xText)
	t17:SetText(eText)
end



